﻿using System;
using System.Windows;
using System.Windows.Controls;

namespace OrientingMap
{
    public partial class MapTile : UserControl
    {
        QuadKey quadKey;

        public MapTile()
        {
            InitializeComponent();
        }

        public QuadKey QuadKey 
        {
            set
            {
                quadKey = value;

                if (quadKey != null)
                {
                    // Debugging purposes
                    txtblk.Text = quadKey.ToString();

                    Refresh();
                }
                else
                {
                    bitmapImage.UriSource = null;
                }
            }
            get
            {
                return quadKey;
            }
        }

        public EventHandler<RoutedEventArgs> ImageOpened
        {
            set
            {
                if (value != null)
                    bitmapImage.ImageOpened += value;
                else
                    bitmapImage.ImageOpened -= value;
            }
        }

        public bool IsImageOpened { protected set; get; }

        public double Scale
        {
            set
            {
                scale.ScaleX = value;
                scale.ScaleY = value;
            }
            get
            {
                return scale.ScaleX;
            }
        }

        public void Refresh()
        {
            this.IsImageOpened = false;
            bitmapImage.UriSource = this.QuadKey.ToUri();
        }

        void OnBitmapImageOpened(object sender, RoutedEventArgs args)
        {
            this.IsImageOpened = true;

            // Not detaching this handler leads to an out-of-memory problem
            bitmapImage.ImageOpened -= OnBitmapImageOpened;
        }
    }
}
